var LOGFILE_NAME = "sonos-controller.log";
var lWarn = {
		logln : function(o) {
		}
	};
	var lInfo = {
		logln : function(o) {
		}
	};


lInfo = new Logger(LOGFILE_NAME);
lWarn = new Logger(LOGFILE_NAME);

Property.setSavedProperty=function (path,value) {
	  Property.setProperty(path, value);
	  Property.setFlag(path, 'ARCHIVE', true);
}

function isRemoteConnectivityActivated() {
	if (Property.getNode('/scripts/system-addon-remote-connectivity/OSPToken')!=null)
		return true;
	return false;
}

function mediaDummyData() {
	if (isRemoteConnectivityActivated())
		return;
	Property.setSavedProperty('media-service/library/b0e4183f-769f-4e21-95fa-7a34c73c5613/id','b0e4183f-769f-4e21-95fa-7a34c73c5613');
	Property.setSavedProperty('media-service/library/b0e4183f-769f-4e21-95fa-7a34c73c5613/name_en_US','Bibliothek');

	Property.setSavedProperty('media-service/library/3e36f94e-8c20-4f3c-8418-51709e32147a/id','3e36f94e-8c20-4f3c-8418-51709e32147a');
	Property.setSavedProperty('media-service/library/3e36f94e-8c20-4f3c-8418-51709e32147a/parent','b0e4183f-769f-4e21-95fa-7a34c73c5613');
	Property.setSavedProperty('media-service/library/3e36f94e-8c20-4f3c-8418-51709e32147a/name_en_US','Alarme');
	Property.setSavedProperty('media-service/library/3e36f94e-8c20-4f3c-8418-51709e32147a/files/0/name_en_US','Alarm 1');
	Property.setSavedProperty('media-service/library/3e36f94e-8c20-4f3c-8418-51709e32147a/files/0/id','0d2c425a-857a-fa88-7511-19355415538a');
	Property.setSavedProperty('media-service/library/3e36f94e-8c20-4f3c-8418-51709e32147a/files/0/url','https://dsmedialibrary.blob.core.windows.net/library/0d2c425a-857a-fa88-7511-19355415538a.mp3');

	Property.setSavedProperty('media-service/library/5f5f01b2-63e8-4131-8e20-ec86e1920d20/id','5f5f01b2-63e8-4131-8e20-ec86e1920d20');
	Property.setSavedProperty('media-service/library/5f5f01b2-63e8-4131-8e20-ec86e1920d20/parent','b0e4183f-769f-4e21-95fa-7a34c73c5613');
	Property.setSavedProperty('media-service/library/5f5f01b2-63e8-4131-8e20-ec86e1920d20/name_en_US','Door bell');
	Property.setSavedProperty('media-service/library/5f5f01b2-63e8-4131-8e20-ec86e1920d20/files/0/name_en_US','Doorbell');
	Property.setSavedProperty('media-service/library/5f5f01b2-63e8-4131-8e20-ec86e1920d20/files/0/id','8b785dbf-04e3-ee66-2dda-9593e2a20a48');
	Property.setSavedProperty('media-service/library/5f5f01b2-63e8-4131-8e20-ec86e1920d20/files/0/url','https://dsmedialibrary.blob.core.windows.net/library/8b785dbf-04e3-ee66-2dda-9593e2a20a48.mp3');

	Property.setSavedProperty('media-service/library/5bcd76bf-ce45-eca1-369e-61c6b60ded70/id','5bcd76bf-ce45-eca1-369e-61c6b60ded70');
	Property.setSavedProperty('media-service/library/5bcd76bf-ce45-eca1-369e-61c6b60ded70/parent','3e36f94e-8c20-4f3c-8418-51709e32147a');
	Property.setSavedProperty('media-service/library/5bcd76bf-ce45-eca1-369e-61c6b60ded70/name_en_US','Fire alarm with announcement');
	
	Property.setSavedProperty('media-service/library/5bcd76bf-ce45-eca1-369e-61c6b60ded70/files/0/name_en_US','German');
	Property.setSavedProperty('media-service/library/5bcd76bf-ce45-eca1-369e-61c6b60ded70/files/0/id','ed520c04-803b-19f9-d6b9-05819134b60d');
	Property.setSavedProperty('media-service/library/5bcd76bf-ce45-eca1-369e-61c6b60ded70/files/0/url','https://dsmedialibrary.blob.core.windows.net/library/ed520c04-803b-19f9-d6b9-05819134b60d.mp3');
	
	Property.setSavedProperty('media-service/library/5bcd76bf-ce45-eca1-369e-61c6b60ded70/files/1/name_en_US','English');
	Property.setSavedProperty('media-service/library/5bcd76bf-ce45-eca1-369e-61c6b60ded70/files/1/id','32c731e1-0171-a846-b291-de55bceeedfa');
	Property.setSavedProperty('media-service/library/5bcd76bf-ce45-eca1-369e-61c6b60ded70/files/1/url','https://dsmedialibrary.blob.core.windows.net/library/32c731e1-0171-a846-b291-de55bceeedfa.mp3');
	
	Property.setSavedProperty('media-service/library/5bcd76bf-ce45-eca1-369e-61c6b60ded70/files/2/name_en_US','French');
	Property.setSavedProperty('media-service/library/5bcd76bf-ce45-eca1-369e-61c6b60ded70/files/2/id','32aa1a01-4833-e4c7-c7e0-ea55ef972f2a');
	Property.setSavedProperty('media-service/library/5bcd76bf-ce45-eca1-369e-61c6b60ded70/files/2/url','https://dsmedialibrary.blob.core.windows.net/library/32aa1a01-4833-e4c7-c7e0-ea55ef972f2a.mp3');
	
	Property.setSavedProperty('media-service/library/5bcd76bf-ce45-eca1-369e-61c6b60ded70/files/3/name_en_US','Dutch');
	Property.setSavedProperty('media-service/library/5bcd76bf-ce45-eca1-369e-61c6b60ded70/files/3/id','c6a40b67-5a31-8652-4f10-73c042029a15');
	Property.setSavedProperty('media-service/library/5bcd76bf-ce45-eca1-369e-61c6b60ded70/files/3/url','https://dsmedialibrary.blob.core.windows.net/library/c6a40b67-5a31-8652-4f10-73c042029a15.mp3');
	
	Property.setSavedProperty('media-service/library/5bcd76bf-ce45-eca1-369e-61c6b60ded70/files/4/name_en_US','Polish');
	Property.setSavedProperty('media-service/library/5bcd76bf-ce45-eca1-369e-61c6b60ded70/files/4/id','92006ecc-c718-9b14-5da5-7d98a4ecb416');
	Property.setSavedProperty('media-service/library/5bcd76bf-ce45-eca1-369e-61c6b60ded70/files/4/url','https://dsmedialibrary.blob.core.windows.net/library/92006ecc-c718-9b14-5da5-7d98a4ecb416.mp3');
	
	Property.setSavedProperty('media-service/library/5bcd76bf-ce45-eca1-369e-61c6b60ded70/files/5/name_en_US','Turkish');
	Property.setSavedProperty('media-service/library/5bcd76bf-ce45-eca1-369e-61c6b60ded70/files/5/id','12be7cf0-7731-981a-4a44-99f8260a6d44');
	Property.setSavedProperty('media-service/library/5bcd76bf-ce45-eca1-369e-61c6b60ded70/files/5/url','https://dsmedialibrary.blob.core.windows.net/library/12be7cf0-7731-981a-4a44-99f8260a6d44.mp3');

	Property.setSavedProperty('media-service/library/66d97d95-663f-4350-3b70-c551486e1ff5/id','66d97d95-663f-4350-3b70-c551486e1ff5');
	Property.setSavedProperty('media-service/library/66d97d95-663f-4350-3b70-c551486e1ff5/parent','3e36f94e-8c20-4f3c-8418-51709e32147a');
	Property.setSavedProperty('media-service/library/66d97d95-663f-4350-3b70-c551486e1ff5/name_en_US','Hail Warning');

	Property.setSavedProperty('media-service/library/66d97d95-663f-4350-3b70-c551486e1ff5/files/0/name_en_US','German');
	Property.setSavedProperty('media-service/library/66d97d95-663f-4350-3b70-c551486e1ff5/files/0/id','ab5fb906-59f3-f3da-8190-bcf680c184ce');
	Property.setSavedProperty('media-service/library/66d97d95-663f-4350-3b70-c551486e1ff5/files/0/url','https://dsmedialibrary.blob.core.windows.net/library/ab5fb906-59f3-f3da-8190-bcf680c184ce.mp3');

	Property.setSavedProperty('media-service/library/66d97d95-663f-4350-3b70-c551486e1ff5/files/1/name_en_US','English');
	Property.setSavedProperty('media-service/library/66d97d95-663f-4350-3b70-c551486e1ff5/files/1/id','ffc09a32-45fb-2492-4998-342c8e8c045e');
	Property.setSavedProperty('media-service/library/66d97d95-663f-4350-3b70-c551486e1ff5/files/1/url','https://dsmedialibrary.blob.core.windows.net/library/ffc09a32-45fb-2492-4998-342c8e8c045e.mp3');

	Property.setSavedProperty('media-service/library/66d97d95-663f-4350-3b70-c551486e1ff5/files/2/name_en_US','French');
	Property.setSavedProperty('media-service/library/66d97d95-663f-4350-3b70-c551486e1ff5/files/2/id','c5d42cb3-5e09-cc95-cbb7-03f214dd6cc6');
	Property.setSavedProperty('media-service/library/66d97d95-663f-4350-3b70-c551486e1ff5/files/2/url','https://dsmedialibrary.blob.core.windows.net/library/c5d42cb3-5e09-cc95-cbb7-03f214dd6cc6.mp3');

	Property.setSavedProperty('media-service/library/66d97d95-663f-4350-3b70-c551486e1ff5/files/3/name_en_US','Dutch');
	Property.setSavedProperty('media-service/library/66d97d95-663f-4350-3b70-c551486e1ff5/files/3/id','a25af6a9-272e-02de-a32e-004bf5d03a9c');
	Property.setSavedProperty('media-service/library/66d97d95-663f-4350-3b70-c551486e1ff5/files/3/url','https://dsmedialibrary.blob.core.windows.net/library/a25af6a9-272e-02de-a32e-004bf5d03a9c.mp3');

	Property.setSavedProperty('media-service/library/66d97d95-663f-4350-3b70-c551486e1ff5/files/4/name_en_US','Polish');
	Property.setSavedProperty('media-service/library/66d97d95-663f-4350-3b70-c551486e1ff5/files/4/id','1b1c9a9c-554d-55ed-e6a4-ea57e8b4fa1b');
	Property.setSavedProperty('media-service/library/66d97d95-663f-4350-3b70-c551486e1ff5/files/4/url','https://dsmedialibrary.blob.core.windows.net/library/1b1c9a9c-554d-55ed-e6a4-ea57e8b4fa1b.mp3');

	Property.setSavedProperty('media-service/library/66d97d95-663f-4350-3b70-c551486e1ff5/files/5/name_en_US','Turkish');
	Property.setSavedProperty('media-service/library/66d97d95-663f-4350-3b70-c551486e1ff5/files/5/id','c884d6c3-f375-f4ab-32a1-c977b133bab2');
	Property.setSavedProperty('media-service/library/66d97d95-663f-4350-3b70-c551486e1ff5/files/5/url','https://dsmedialibrary.blob.core.windows.net/library/c884d6c3-f375-f4ab-32a1-c977b133bab2.mp3');
	
	Property.store();
}

function fetchSpeechConfiguration(fShouldQueueLibrary) {
	if (!isRemoteConnectivityActivated()) {
		return;
	}
	if (fShouldQueueLibrary==null)
		fShouldQueueLibrary=false;
	try {
		lInfo.logln('start fetchSpeechConfiguration');
		cloudService.fetchText2SpeechConf(function (oData) {
			lInfo.logln('getting fetchSpeechConfiguration: ' + JSON.stringify(oData));
			if (oData!=null) {
				if (oData.ReturnCode != null)
					if (oData.ReturnCode == 0) {
					if (Property.getNode('media-service')!=null)
						Property.getNode('media-service').removeChild('speech');
					
					for (var iIndex = 0; iIndex < oData.Response.LanguageCodeList.length; iIndex++) {
						var sLangCode=oData.Response.LanguageCodeList[iIndex].LanguageCode;
						sLangCode=sLangCode.replace('-','_');
						Property.setSavedProperty('media-service/speech/languages/' + sLangCode + '/code',sLangCode);
						for (var jIndex=0;jIndex<oData.Response.LanguageCodeList[iIndex].VoiceNameList.length;jIndex++) {
							Property.setSavedProperty('media-service/speech/languages/' + sLangCode + '/voices/'+jIndex+'/name',
									oData.Response.LanguageCodeList[iIndex].VoiceNameList[jIndex].VoiceName);
							Property.setSavedProperty('media-service/speech/languages/' + sLangCode + '/voices/'+jIndex+'/id',
									oData.Response.LanguageCodeList[iIndex].VoiceNameList[jIndex].VoiceId);
						}
					}
					Property.setSavedProperty('media-service/speech/maxCalls',oData.Response.MaxTextToSpeechCalls);
					Property.setSavedProperty('media-service/speech/maxTextLength',oData.Response.MaxTextToSpeechLength);          
					Property.setSavedProperty("media-service/isConnectivityAvailable",true);
					Property.setSavedProperty("media-service/isServiceConnected",true);
					lInfo.logln("fetchSpeechConfiguration returnCode="+oData.ReturnCode);
					if (fShouldQueueLibrary) {
						new Event('sonos.cloud',{actions:'startMultilanguageLibrary'}).raise();
					}
				}
			}
			else 
				lInfo.logln("fetchSpeechConfiguration empty return");      
		});    
	} catch (e) {
		lWarn.logln('fetchSpeechConfiguration error ' + e);
	}
}

function createTextSound(sVoiceName, sText) {	
	if (!isRemoteConnectivityActivated()) {
		new Event("sonos.saved", {actions:'text2Speech',error:-1}).raise();
		return;
	}
	try {
		var oNodeArray=Property.getNode('media-service/speech/languages').getChildren();
		var lang_id="";
		for (var iIndex=0;iIndex<oNodeArray.length;iIndex++) {
			var id=oNodeArray[iIndex].getChild('code').getValue();
			var oSubArray=oNodeArray[iIndex].getChild('voices').getChildren();
			for (var jIndex=0;jIndex<oSubArray.length;jIndex++) {
				if (oSubArray[jIndex].getChild('id').getValue()==sVoiceName)
					lang_id=id;
			}
		}
		lang_id=lang_id.replace('_','-');
		cloudService.createTextSound(lang_id, sVoiceName, sText, function (oData) {
			lInfo.logln('getting createTextSound: ' + JSON.stringify(oData));
			if (oData!=null) {
				if (oData.ReturnCode != null && oData.ReturnCode == 0) {
					cloudService.fetchMediaFile(oData.Response.TextToSpeechVoiceFileGuid, function(oSubData) {
						lInfo.logln('getting fetchMediaFile: ' + JSON.stringify(oSubData));
						if (oSubData.ReturnMessage == "OK") {
							Property.setSavedProperty('media-service/speech/texts/' + oData.Response.TextToSpeechVoiceFileGuid + '/guid', oData.Response.TextToSpeechVoiceFileGuid);
							Property.setSavedProperty('media-service/speech/texts/' + oData.Response.TextToSpeechVoiceFileGuid + '/url', oSubData.Response.UrlPath);
							Property.setSavedProperty('media-service/speech/texts/' + oData.Response.TextToSpeechVoiceFileGuid + '/text', escape(sText));
							Property.setSavedProperty('media-service/speech/texts/' + oData.Response.TextToSpeechVoiceFileGuid + '/voice', sVoiceName);
							
							var text2speech=Property.getProperty('media-service/t2SpeechBase');
							var newIndex=-1;
							if (Property.getNode('media-service/library/' + text2speech+'/files')!=null) {
								var oMediaFileNodes=Property.getNode('media-service/library/' + text2speech+'/files').getChildren();		
								for (var iIndex=0;iIndex<oMediaFileNodes.length;iIndex++) {
									var nameID=parseInt(oMediaFileNodes[iIndex].getName(),10);
									if (newIndex<nameID)
										newIndex=nameID;
								}
							}
							lInfo.logln('extending manually ' + 'media-service/library/' + text2speech+'/files/'+(nameID+1)+'/id');
							Property.setSavedProperty('media-service/library/' + text2speech+'/files/'+(nameID+1)+'/id',oData.Response.TextToSpeechVoiceFileGuid);
							Property.setSavedProperty('media-service/library/' + text2speech+'/files/'+(nameID+1)+'/url',oSubData.Response.UrlPath);
							Property.setSavedProperty('media-service/library/' + text2speech+'/files/'+(nameID+1)+'/name',"");
							
							Property.store();
							if (raisedEvent.parameter.answerEvent==null) {
								lInfo.logln('no answer event');
								var evt = new Event("sonos.saved", {actions:'text2Speech',error:0,guid:oData.Response.TextToSpeechVoiceFileGuid,url:oSubData.Response.UrlPath}).raise();
							} else {
								lInfo.logln('relaying answer event');
								var oAnswer=JSON.parse(raisedEvent.parameter.answerEvent);
								if (oAnswer.parameter==null)
									oAnswer.parameter={};

								oAnswer.parameter.guid=oData.Response.TextToSpeechVoiceFileGuid;
								oAnswer.parameter.contentSrc=oSubData.Response.UrlPath;
								lInfo.logln('relaying event back to '+ oAnswer.name +' with '+ JSON.stringify(oAnswer.parameter));
								var evt = new Event(oAnswer.name, oAnswer.parameter).raise();
							} 
								
							lInfo.logln("createTextSound returnCode=" + JSON.stringify(oSubData));
							return;
						}
						new Event("sonos.saved", {actions:'text2Speech',error:-1}).raise();
					});
					return;
				} 
			}
			else 
				lInfo.logln("createTextSound empty return");
			
			new Event("sonos.saved", {actions:'text2Speech',error:-1}).raise();
      
		});
	} catch (e) {
		lWarn.logln('fetchMediaLibrary error ' + e);
	}
}

function fetchFile(guid,path) {
	cloudService.fetchMediaFile(unescape(guid), function(oData) {
		if (oData.ReturnMessage == "OK") {
			var sUrl = oData.Response.UrlPath;
			lInfo.logln('setting ' + unescape(path) +  ' to  !' + sUrl+ '!');
			Property.setProperty(unescape(path),'' + sUrl);
			Property.setFlag(unescape(path), 'ARCHIVE', true);
			Property.store();
		}
	});
}


function fetchFileQueue(fShouldQueueSpeechRequest) {
	var sQueue=raisedEvent.parameter.queue;
	var queue=JSON.parse(sQueue);	
	var iIndex=parseInt(''+raisedEvent.parameter.index,10);
	lInfo.logln('fetching file async index ' + iIndex + ' from queue ' + sQueue);
	if (iIndex<queue.length)
		cloudService.fetchMediaFile(unescape(queue[iIndex].guid), function(oData) {		
			if (oData.ReturnMessage == "OK") {
				var sUrl = oData.Response.UrlPath;
				lInfo.logln('setting ' + unescape(queue[iIndex].path) +  ' to  !' + sUrl+ '!');
				Property.setProperty(unescape(queue[iIndex].path),'' + sUrl);
				Property.setFlag(unescape(queue[iIndex].path), 'ARCHIVE', true);
				Property.store();
				new Event('sonos.cloud',{actions:'fetchFileAsyncQueue',queue:sQueue,index:(iIndex+1),time:'+2',shouldQueueSpeechRequest:fShouldQueueSpeechRequest}).raise();
			}
		});
	else {
		lInfo.logln('queue finished');
		if (fShouldQueueSpeechRequest)
			new Event('sonos.cloud',{actions:'fetchSpeechConfig'}).raise();
	}
}

function deleteSoundQueue() {
	var sQueue=raisedEvent.parameter.queue;
	var queue=JSON.parse(sQueue);	
	var iIndex=parseInt(''+raisedEvent.parameter.index,10);
	var guid=queue[iIndex];
	lInfo.logln('deleting file async index ' + iIndex + ' from queue ' + sQueue);
	if (iIndex<queue.length)
		cloudService.deleteTextSound(guid, function(oData) {
			lInfo.logln('removing guid ' + guid)
			if (Property.getNode('media-service/speech/texts')!=null) {
				Property.getNode('media-service/speech/texts').removeChild(guid);
			}
			var text2speech=Property.getProperty('media-service/t2SpeechBase');
			var oMediaFileNodes=Property.getNode('media-service/library/' + text2speech+'/files').getChildren();		
			for (var jIndex=0;jIndex<oMediaFileNodes.length;jIndex++) {
				if (oMediaFileNodes[jIndex].getChild('id').getValue()==guid) {
					lInfo.logln('removing libchild: ' + oMediaFileNodes[jIndex].getPath());
					Property.getNode('media-service/library/' + text2speech+'/files').removeChild(oMediaFileNodes[jIndex].getName());
				}
			}
			Property.store();
			new Event('sonos.cloud',{actions:'deleteTextSoundQueue',queue:sQueue,index:(iIndex+1),time:'+2'}).raise();
		});
	
		
}

function deleteSound(guid) {
	cloudService.deleteTextSound(guid,function(oData) {
		if (Property.getNode('media-service/speech/texts')!=null) {
			Property.getNode('media-service/speech/texts').removeChild(guid);
			var text2speech=Property.getProperty('media-service/t2SpeechBase');
			var oMediaFileNodes=Property.getNode('media-service/library/' + text2speech+'/files').getChildren();		
			for (var iIndex=0;iIndex<oMediaFileNodes.length;iIndex++) {
				if (oMediaFileNodes[iIndex].getChild('id').getValue()==guid) {
					Property.getNode('media-service/library/' + text2speech+'/files').removeChild(oMediaFileNodes[iIndex].getName());
				}
			}
			Property.store();
		}
	});
}

function cleanupSounds() {
	try {
		var oEntryNodes=Property.getNode('entries').getChildren();
		var oTextEntry=[];
		var oRemoveEntry=[];
		for (var iIndex=0;iIndex<oEntryNodes.length;iIndex++) {
			if (oEntryNodes[iIndex].getChild('action/guid')!=null) 
				if (oEntryNodes[iIndex].getChild('action/type')!=null) {
				if ((oEntryNodes[iIndex].getChild('action/type').getValue()=='text2speech') || (oEntryNodes[iIndex].getChild('action/type').getValue()=='library'))
					oTextEntry.push(oEntryNodes[iIndex].getChild('action/guid').getValue())
			}
		}
		lInfo.logln('should not remove id ' + JSON.stringify(oTextEntry));
		var text2speech=Property.getProperty('media-service/t2SpeechBase');
		if (Property.getNode('media-service/library/' + text2speech+'/files')!=null) {
			var oMediaFileNodes=Property.getNode('media-service/library/' + text2speech+'/files').getChildren();		
			for (var iIndex=0;iIndex<oMediaFileNodes.length;iIndex++) {
				var fFound=false;
				var id=oMediaFileNodes[iIndex].getChild('id').getValue();
				for (var jIndex=0;jIndex<oTextEntry.length;jIndex++)
					if (oTextEntry[jIndex]==id)
						fFound=true;
				if (!fFound)
					oRemoveEntry.push(id);
			}
			lInfo.logln('should remove id ' + JSON.stringify(oRemoveEntry));
			new Event('sonos.cloud',{actions:'deleteTextSoundQueue',queue:JSON.stringify(oRemoveEntry),index:"0"}).raise();
		}
	} catch (e) {
		lWarn.logln(e);
	}
}

function startUp() {
	if (!isRemoteConnectivityActivated())
		return;
	cloudService.startService(function() {
		new Event('sonos.cloud',{actions:'startMultilanguageSpeechLibrary'}).raise();
	});
}

function startMultilanguageLibrary() {
	if (!isRemoteConnectivityActivated())
		return;
	var sLangCode=[];
	if (Property.getNode('media-service/speech/languages')==null) {
		lWarn.logln('missing Language Array');
		return;
	}
	var oLangArray=Property.getNode('media-service/speech/languages').getChildren();
	for (var iIndex=0;iIndex<oLangArray.length;iIndex++)  {
		sLangCode.push(oLangArray[iIndex].getName());
	}
	if (Property.getNode('media-service')!=null)
		Property.getNode('media-service').removeChild('library');
	Property.store();
	new Event('sonos.cloud',{actions:'queueMultilanguageLibrary',index:0,langArray:JSON.stringify(sLangCode)}).raise();
}

function queueMultilanguageLibrary() {
	
	if (Property.getNode('startedAt[1]')!=null) {
		lInfo.logln('Other Script is Running, just wait 3 seconds');
		new Event('sonos.cloud',{actions:'queueMultilanguageLibrary',time:'+3',index:raisedEvent.parameter.index,langArray:raisedEvent.parameter.langArray}).raise();
		return;
	}
	
	
	var oLangArray=JSON.parse(raisedEvent.parameter.langArray);
	var index=parseInt("" + raisedEvent.parameter.index,10);
	var sLangCode=oLangArray[index];
	if (index<oLangArray.length) {
		lInfo.logln('fetch now lang ' + sLangCode);
		
		cloudService.fetchMediaLibrary(function (oData) { 
			var mediaObject = null;
			var asyncFetchQueue=[];
			if (oData!=null) {
				if (oData.ReturnCode != null)
					if (oData.ReturnCode == 0) {
						lInfo.logln('data ' + JSON.stringify(oData));

						mediaObject = oData.Response.MediaLibraryTreeList;
						
						for (var jIndex=0;jIndex<mediaObject.length;jIndex++) {
						
							var object=mediaObject[jIndex];
							var folderID=object.MediaLibraryTreeBranchGUID;
							var path='media-service/library/' + folderID;
							var fShouldQueryURL=false;
							if (object.MediaLibraryTreeBranchParentGUID==null) {
								if (object.BranchName=='Text to speech') {
									Property.setSavedProperty('media-service/t2SpeechBase',folderID);
									fShouldQueryURL=true;
								}
							} else {
								Property.setSavedProperty(path + '/parent',object.MediaLibraryTreeBranchParentGUID);
							}
							Property.setSavedProperty(path + '/id',folderID);
							Property.setSavedProperty(path+'/name_' + sLangCode,object.BranchName);
							
							for (var iIndex=0;iIndex<object.MediaFileList.length;iIndex++) {
								var subPath=path+'/files/' + iIndex;
								
								if (Property.getNode(path+'/files/')!=null) {
									var existingNodeArray=Property.getNode(path+'/files/').getChildren();
									for (var kIndex=0;kIndex<existingNodeArray.length;kIndex++) {
										if (existingNodeArray[kIndex].getChild('id')!=null)
											if (existingNodeArray[kIndex].getChild('id').getValue()==object.MediaFileList[iIndex].MediaLibraryTreeMediaFileGUID)
												subPath=existingNodeArray[kIndex].getPath();
									}
								}
								Property.setSavedProperty(subPath + '/id',object.MediaFileList[iIndex].MediaLibraryTreeMediaFileGUID);
								Property.setSavedProperty(subPath + '/name_' + sLangCode,object.MediaFileList[iIndex].MediaFileName);
								if (Property.getNode(subPath+ '/url')==null) {
									if (fShouldQueryURL) 
										asyncFetchQueue.push({guid:object.MediaFileList[iIndex].MediaLibraryTreeMediaFileGUID,path:subPath + '/url'});
									else
										Property.setSavedProperty(subPath + '/url','https://dsmedialibrary.blob.core.windows.net/library/' + object.MediaFileList[iIndex].MediaLibraryTreeMediaFileGUID + '.mp3');
								}
							}
						}
						Property.setSavedProperty("media-service/isConnectivityAvailable",true);
						Property.setSavedProperty("media-service/isServiceConnected",true);
						if (asyncFetchQueue.length>0) {
							lInfo.logln('should fetch a couple of files async ' + asyncFetchQueue.length);
							new Event('sonos.cloud',{actions:'fetchFileAsyncQueue',queue:JSON.stringify(asyncFetchQueue),index:0,shouldQueueSpeechRequest:false}).raise();
						}
						new Event('sonos.cloud',{actions:'queueMultilanguageLibrary',/*time:'+10',*/index:(index+1),langArray:raisedEvent.parameter.langArray}).raise();
						
					}
			} else 
				lInfo.logln("fetchMediaLibrary empty return");
		},sLangCode);
	} else {
		lInfo.logln('queued fetch done');
		Property.store();
	}
			
}

if (raisedEvent.name === 'sonos.cloud') {
	Property.load();
	if (raisedEvent.parameter.actions=='startup') {
		mediaDummyData();
		startUp();
	}
	if (raisedEvent.parameter.actions=='fetchFileAsync') {
		fetchFile(raisedEvent.parameter.guid,raisedEvent.parameter.path);
	} else if (raisedEvent.parameter.actions=='fetchFileAsyncQueue') {
		fetchFileQueue(raisedEvent.parameter.shouldQueueSpeechRequest);
	} else if (raisedEvent.parameter.actions=='fetchSpeechConfig') {
		lWarn.logln('getSpeechConf'); 
		fetchSpeechConfiguration();
		Property.store();
	} else if (raisedEvent.parameter.actions=='createTextSound') {
		lWarn.logln('createTextSound'); 
		
		createTextSound(raisedEvent.parameter.voiceName, raisedEvent.parameter.text);
	}
	else if (raisedEvent.parameter.actions=='deleteTextSound') {
		deleteSound(raisedEvent.parameter.value);
	} 
	else if (raisedEvent.parameter.actions=='deleteTextSoundQueue') {
		deleteSoundQueue();
	} 
	else if (raisedEvent.parameter.actions=='cleanupTextSounds') {
		cleanupSounds();
	}
	else if (raisedEvent.parameter.actions=='startMultilanguageSpeechLibrary') {
		fetchSpeechConfiguration(true);
	}
	else if (raisedEvent.parameter.actions=='startMultilanguageLibrary') {
		startMultilanguageLibrary();
	}
	else if (raisedEvent.parameter.actions=='queueMultilanguageLibrary') {
		queueMultilanguageLibrary();
	}
}